////////////////////////////////////////////////////////////////////////////////
// MAIN.C - 4-level grayscale demo
////////////////////////////////////////////////////////////////////////////////
#include <pager.h>
#include <ribbon.h>
#include "icon.h"
#include "gfx.h"

char VersionPtr[] = "Grayscale2";
int AppStackSize = 1000;

void GS2Thread(void)
{
  int current,light,dark;
  MESSAGE msg;
  PID pid;
  pid.Name = VersionPtr;
  pid.EnableForeground = TRUE;
  pid.Icon = NULL;
  RimSetPID(&pid);
  RimRequestForeground(RimGetCurrentTaskID());
  LcdCopyBitmapToDisplay(&dplane,0,0);
  current = LcdGetDisplayContext();
  dark = LcdCreateDisplayContext(current);
  LcdCopyBitmapToDisplay(&lplane,0,0);
  current = LcdGetDisplayContext();
  light = LcdCreateDisplayContext(current);

  for (;;) // Start message loop
  {
    while(RimPeekMessage()==FALSE)
    {
      LcdSetDisplayContext(dark);
      RimSleep(1);

      LcdSetDisplayContext(light);
      RimSleep(3);


      RimTaskYield();
    }
    RimGetMessage(&msg);
    switch (msg.Device)
    {
      case DEVICE_KEYPAD:
        switch (msg.Event)
        {
          case KEY_DOWN:
          {
            switch (msg.SubMsg)
            {
              case KEY_ESCAPE:  // ESCAPE key exits
                RibbonShowRibbon();
                RimTerminateThread();
                break;
            }
            break;
          }
        }
    }
  } // Message loop
}

void PagerMain(void)
{
  RibbonRegisterFunction(VersionPtr, &IconBMP, 0, 40, GS2Thread, AppStackSize);
}
